/* Rekurzija z memoizacijo: porabi O(n^2 2^n) asa in O(2^n) pomnilnika.
   Deluje dovolj hitro do priblino n = 22. */

#include <stdio.h>
#include <stdlib.h>
#include <assert.h>

#define MaxN 1000
#define Assert assert

int n;
char *f;
char s[MaxN + 3];

int Resi(int x)
{
	int i, j, y, naj = n + 1, kand;
	if (f[x] >= 0) return f[x];
	for (i = 0; i < n; i++) if ((x >> i) & 1)
	{
		y = x & ~(1 << i);
		for (j = i + 1; j < n; j++) if ((x >> j) & 1)
		{
			if (s[i] != s[j]) break;
			y &= ~(1 << j);
		}
		kand = Resi(y) + 1;
		if (kand < naj) naj = kand;
	}
	f[x] = (char) naj;
	if (0) { printf("f["); for (i = 0; i < n; i++) if ((x >> i) & 1) printf("%c", s[i]); printf("] = %d\n", naj); }
	return naj;
}

int main(int argc, char** argv)
{
	int i, j, ok_;
	FILE *g = fopen(argc > 1 ? argv[1] : "brisanje.in", "rt");
	ok_ = fscanf(g, "%d\n", &n);
	Assert(ok_ == 1);
	Assert(1 <= n); Assert(n <= 1000);
	fgets(s, sizeof(s), g);
	fclose(g);

	f = (char *) malloc(1 << n);
	for (i = 0; i < (1 << n); i++) f[i] = -1;
	f[0] = 0;
	for (i = 0; i < n; i++) f[1 << i] = 1;

	Resi((1 << n) - 1);

	g = fopen(argc > 2 ? argv[2] : "brisanje.out", "wt");
	fprintf(g, "%d\n", (int) f[(1 << n) - 1]);
	free(f); fclose(g); return 0;
}
