/* Reitev s spodnjimi mejami.  Ta porabi le O(n + k) asa, e ne tejemo
   asa urejanja obeh tabel.
   Pred tem e O(n log n) za urejanje zabojnikov + O(k log k) za urejanje letal. */

#include <stdio.h>
#include <stdlib.h>
#include <assert.h>

#define Assert assert
#define MaxN 100000
#define MaxK 100000
#define MaxMi 1000000000
#define MaxCj 1000000000

int Primerjaj(const void *x, const void *y) { return *(const int *) y - *(const int *) x; }

int mi[MaxN], cj[MaxK], n, k;

int main(int argc, char** argv)
{
	int ok_, i, j, t, kand;
	/* Preberimo vhodne podatke. */
	FILE *f = fopen(argc > 1 ? argv[1] : "letala.in", "rt");
	ok_ = fscanf(f, "%d %d\n", &n, &k);
	Assert(ok_ == 2);
	Assert(1 <= n); Assert(n <= MaxN);
	Assert(1 <= k); Assert(k <= MaxK);
	for (i = 0; i < n; i++) { ok_ = fscanf(f, "%d", &mi[i]);
		Assert(ok_ == 1); Assert(1 <= mi[i]); Assert(mi[i] <= MaxMi); }
	for (j = 0; j < k; j++) { ok_ = fscanf(f, "%d", &cj[j]);
		Assert(ok_ == 1); Assert(1 <= cj[j]); Assert(cj[j] <= MaxCj); }
	fclose(f);
	/* Uredimo zabojnike in letala padajoe. */
	qsort(mi, n, sizeof(mi[0]), &Primerjaj);
	qsort(cj, k, sizeof(cj[0]), &Primerjaj);
	/* Poiimo najmanji t z bisekcijo. */
	if (mi[0] > cj[0]) t = -1;
	else for (i = 0, j = 1, t = 0; j <= k; j++)
	{
		/* Za koliko zabojnikov velja, da jih lahko peljejo letala od 0 do j - 1,
		   letala od j do k-1 pa ne? */
		if (j == k) i = n;
		else while (i < n && mi[i] > cj[j]) i++;
		/* Teh i zabojnikov lahko torej razvozi le najmonejih j letal,
		   za kar bo potrebnih vsaj i/j dni.  Ker mora biti tevilo dni celo,
		   bomo kolinik i/j zaokroili navzgor. */
		kand = (i + j - 1) / j;
		if (0) printf("j = %d [%d], i = %d -> kand = %d\n", j, j < k ? cj[j] : -1, i, kand);
		if (kand > t) t = kand;
	}
	/* Izpiimo rezultat. */
	f = fopen(argc > 2 ? argv[2] : "letala.out", "wt");
	fprintf(f, "%d\n", t); fclose(f); return 0;
}
